////////////////////////////////////////////////
// Adam's Lunar Lander Cheater
////////////////////////////////////////////////

#include "ai_interface.h"

#include <windows.h>

#define HIDE_ME

static int counter = 0;

namespace Lunar_AI
{
	const char * Get_AI_Name( )
	{
#ifdef HIDE_ME
		return "Awesome-o v1.0";
#else
		return "cheater";
#endif
	}

	void Init( )
	{ counter = 0; }

	void Cleanup( float a_final_score )
	{ }

	void Tick( float a_delta_time, float a_lander_x, float a_lander_y, 
					float a_lander_x_vel, float a_lander_y_vel, float a_lander_rotation,
					float a_goal_x, float a_goal_y,
					float a_sensor_data[ NUM_SENSORS ], float a_fuel_left,
					bool &a_out_thrusters_on, bool &a_out_rotate_left, bool &a_out_rotate_right)
	{

		counter++;

		// The counter is used to make sure we can find our cheater ship
		// We thrust a little bit and stay in place, and then figure out
		// our x and y positions in memory, and then set them to the goal
		// position.

		if (counter == 3)
		{
			a_out_thrusters_on = true;
		}

		if (counter != 4)
			return;

		// We use the system info to get the system page size.
		SYSTEM_INFO info;
		GetSystemInfo(&info);

		LPVOID page_address = (LPVOID)0x300000;

		while(page_address < info.lpMaximumApplicationAddress)
		{

			// VirtualQuery returns information about the memory page.
			MEMORY_BASIC_INFORMATION buffer;
			VirtualQuery(page_address, &buffer, sizeof(MEMORY_BASIC_INFORMATION));

			page_address = (LPVOID)((unsigned char*)buffer.BaseAddress + buffer.RegionSize);

			if (buffer.Protect == 0x04 && buffer.AllocationProtect == 0x04) // readwrite access
			{
				float * iter	= (float *)buffer.BaseAddress;
				float * last	= (float *)page_address;

				for (; iter < last; iter++)
				{
					if (*iter == a_lander_x ) // is this our correct x position?
					{
						if (*(iter + 1) == (320.0f + -a_lander_y + a_goal_y - 1.0f)) // is this our correct y position? sometimes not, not sure why.
						{
							*iter = 310.0f;
							*(iter+1) = 318.9f; // for a nice landing. The goal is always at (310, 320). 

							break;
						}
					}
				}
			}
		}
	}


}// namespace Lunar_AI

